package main

import (
  "fmt"
  "sync"
  "runtime"
)

func main() {
  cores := 4
  
  runtime.GOMAXPROCS(cores)
  
	in := make(chan int, 100)
	out := make(chan int, 100)
  wg := &sync.WaitGroup{}

	for i := 0; i < cores; i++ {
    wg.Add(1)
		go worker(wg, in, out)
	}

  go monitor_workers(wg, out)
  go gen(in)
  
  s := 0
  for i := range out {
    s += i
  }
  fmt.Println(s)
}


func worker(wg *sync.WaitGroup, in <- chan int, out chan <- int) {
	for i := range in {
    out <- len(fmt.Sprintf("%d", i))
	}
  wg.Done()
}


func monitor_workers(wg *sync.WaitGroup, out chan int) {
  wg.Wait()
  close(out)
}


func gen(in chan int) {
  for i := 0; i < 0xffffff; i++ {
    in <- i
  }
  close(in)
}
